// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <aoc/LinesSolver.hpp>

class GuardGallivant
    : public LinesSolver
{
public:
    virtual const std::string getPuzzleName() const override;
    virtual const std::string getInputFileName() const override;
    virtual void processDataLine(const std::string& line) override;
    virtual void finish() override;
private:
    static constexpr size_t getStartDirectionIndex();
    static constexpr char getStartChar();
    static constexpr char getVisitedChar();
    static constexpr char getObstructionChar();
    Point2 start_{};
    void visitPosition(const Point2& current);
    size_t turnDirection(const size_t current) const;
};
