// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Müller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#include <aoc/LinesSolver.hpp>

void LinesSolver::processDataLine(const std::string& line)
{
    lines.push_back(line);
}

bool LinesSolver::isInBounds(const Point2& point) const
{
    return 0 <= point.y && point.y < lines.size() &&
        0 <= point.x && point.x < lines[point.y].size();
}

char LinesSolver::getPosition(const Point2& point) const
{
    return lines[point.y][point.x];
}

void LinesSolver::setPosition(const Point2& point, const char value)
{
    lines[point.y][point.x] = value;
}
